#!/bin/bash
#
#$ -cwd
#$ -j y
#$ -S /bin/bash
#
###THIS ASSUMES THAT USENGNSD IS ENGLISH AND SPANISHNCD IS SPANISH.  THERE IS NO TAWAIN,USENGSD,SPANISHCD

#trainSets="rec_canadian_train rec_farsi_train rec_german_train"
####UNCOMMENT FOLLOWING TWO LINES FOR FULL EVALUATON
trainSets="rec_arabic_train rec_english_train rec_farsi_train rec_french_train rec_german_train rec_hindi_train rec_japanese_train rec_korean_train rec_mandarin_train rec_spanish_train rec_tamil_train rec_vietnamese_train"
trainlans=("arabic" "english" "farsi" "french" "german" "hindi" "japanese" "korean" "mandarin" "spanish" "tamil" "vietnamese" "norwegian")
#trainSets="rec_arabic_train"
#trainlans=("arabic")

####COMMENT THE FOLLOWING LINE FOR FULL EVALUATION
#trainlans=("canadian" "farsi" "german") #changed from arabic and german to canadian and farsi -øystein

testSet="rec_lid03e1_30"

numSV=$1
weight=$2
rm -rf nist
mkdir nist

for set in `echo $trainSets`
  do
	echo $set
done

echo "special treatment for Norwegian"
for set in `echo rec_norwegian_train`; do
	mkdir nist/$set
	perl breakNIST.pl $set.mlf place
	ls nist/$set > nist/curSet.scp
	perl replaceNAFTAPhns.pl place $set
	mkdir nist/temp30
	matlab -nodisplay -nodesktop -nojvm -r "combineNAFTA('nist/curSet.scp','$set')"
	rm -rf nist/$set
	mv nist/temp30 nist/$set
	perl listFiles.pl "nist/$set" >> nist/all.scp
done

for set in `echo $trainSets`
  do
  echo $set
  mkdir nist/$set
  perl breakNIST.pl $set.mlf place
  perl listCALL.pl $set
  perl replacePhns.pl place $set
  mkdir nist/temp30
  matlab -nodisplay -nodesktop -nojvm -r "combineCALL('nist/setCount.txt','$set')"
  rm -rf nist/$set
  mv nist/temp30 nist/$set
  perl listFiles.pl "nist/$set" >> nist/all.scp
done

perl mkLabels.pl "nist/all.scp" "nist/train.lab"

echo "Done making training files"
echo "Making testing file"
mkdir nist/$testSet
perl breakNIST.pl $testSet.mlf
perl listNIST.pl $testSet

perl replacePhns.pl place $testSet
mkdir nist/temp30
matlab -nodisplay -nodesktop -nojvm -r "combineNIST('nist/setCount.txt','$testSet')"
rm -rf nist/$testSet
mv nist/temp30 nist/$testSet
perl listFiles.pl "nist/$testSet" > nist/test.scp
perl mkTestLabs.pl "$testSet"
echo "Done making testing files"
  
numPhns=`wc -l phn_place | awk '{ print $1 }'`
echo "Num svs = $numSV"
matlab -nodisplay -nodesktop -nojvm -r "quadlsaNIST('nist/all.scp','nist/test.scp',$numPhns,$numSV)"
#matlab -r "quintlsa('nist/all.scp','nist/test.scp',$numPhns,$numSV)" #was commented
matlab -nodisplay -nodesktop -nojvm -r "normVects('nist')"
##mv nist/train.csv nist/trainNorm.csv #was commented
##mv nist/test.csv nist/testNorm.csv	#was commented

for ((pos=0;pos<${#trainlans[@]};pos++))
  do
  set=${trainlans[$pos]}
  echo "$set"
  perl mkSVM1vAll.pl nist/trainNorm.csv nist/train.lab ${set} nist/${set}.dat
  perl mkSVM1vAll.pl nist/testNorm.csv nist/test.lab $set nist/test.dat
  svm_learn -j ${weight} nist/${set}.dat nist/theModel
  svm_classify nist/test.dat nist/theModel nist/${set}.pred
  svm_classify nist/${set}.dat nist/theModel nist/${set}.predT
#  perl svm2scores.pl nist $set nist/test.lab nist/${set}.pred
done > NISTsvmlog.txt
