function findEERNIST1v1(nmixYes,nmixNo,thresh)

trainlabs{1} = 'arabic';
trainlabs{2} = 'english';
trainlabs{3} = 'farsi';
trainlabs{4} = 'french';
trainlabs{5} = 'german';
trainlabs{6} = 'hindi';
trainlabs{7} = 'japanese';
trainlabs{8} = 'korean';
trainlabs{9} = 'mandarin';
trainlabs{10} = 'spanish';
trainlabs{11} = 'tamil';
trainlabs{12} = 'vietnamese';

scores = [];
counter = 1;
for n = 1:(length(trainlabs)-1)
  for m = (n+1):length(trainlabs)
    str = sprintf('nist/%svs%s.predT',trainlabs{n},trainlabs{m});
    scores(:,counter) = dlmread(str);
    counter = counter + 1;
  end
end

testscores = [];
counter = 1;
for n = 1:(length(trainlabs)-1)
  for m = (n+1):length(trainlabs)
    str = sprintf('nist/%svs%s.pred',trainlabs{n},trainlabs{m});
    testscores(:,counter) = dlmread(str);
    counter = counter + 1;
  end
end
testLabels = textread('nist/test.lab','%s');
[numLabs,ndim] = size(testscores);
if (numLabs ~= length(testLabels))
  error('ERROR!')
end
TP = 0;
FP = 0;
TN = 0;
FN = 0;
trainLabels = textread('nist/train.lab','%s');
for n = 1:length(trainlabs)
  gmmYes = gmm(ndim,nmixYes,'diag');
  gmmNo = gmm(ndim,nmixNo,'diag');
  options = foptions;
  options(14) = 10;
  I = find(strcmp(trainLabels,trainlabs{n})==1);
  gmmYes = gmminit(gmmYes,scores(I,:),options);
  J = find(strcmp(trainLabels,trainlabs{n})~=1);
  gmmNo = gmminit(gmmNo,scores(J,:),options);
  emoptions = zeros(1,18);
  emtions(14) = 20;
  gmmYes = gmmem(gmmYes,scores(I,:),emoptions);
  gmmNo = gmmem(gmmNo,scores(J,:),emoptions);
  for k = 1:numLabs
    testLLR = log(gmmprob(gmmYes,testscores(k,:)))-log(gmmprob(gmmNo,testscores(k,:)));
    if (strcmp(testLabels{k},trainlabs{n})==1)
      if (testLLR > thresh)
	TP = TP + 1;
      else
	FN = FN + 1;
      end
    else
      if (testLLR < thresh)
	TN = TN + 1;
      else
	FP = FP + 1;
      end
    end
  end
end

%str = sprintf('Thresh %1.3f: TP = %d,TN = %d,FP = %d,FN = %d',thresh,TP,TN,FP,FN);
FA = FP/(TN+FP);
FR = TN/(TP+FN);
str = sprintf('Thresh %1.3f: FA = %.3f,FR = %.3f',thresh,FA,FR);
disp(str)
