function lsa(trainList,testList,numWords,numSV)

fileList = textread(trainList,'%s');
C = zeros(numWords+numWords*numWords,length(fileList));
numDocs = length(fileList);
for fileNum = 1:numDocs
  x = dlmread(fileList{fileNum});
  for n = 1:numWords
    C(n,fileNum) = length(find(x == n));
  end
  temp = zeros(numWords,numWords);
  for n = 2:length(x)
    temp(x(n),x(n-1)) = temp(x(n),x(n-1)) + 1;
  end
  C((numWords+1):end,fileNum) = temp(:);
end
dlmwrite('C.txt',C,' '); %<---Remove this after done debugging

W = zeros(size(C));
n = sum(C);
t = sum(C');
epsilon = zeros(1,numWords+numWords*numWords);

for ii = 1:length(t)
  if (t(ii) > 0)
    temp = C(ii,:)./t(ii);
    temp = temp.*log(temp);
    I = find(C(ii,:) == 0);
    temp(I) = 0;
    epsilon(ii) = -1/log(numDocs) * sum(temp);
  end
end

dlmwrite('wordEntropies.txt',epsilon,'\n'); %<---Remove this after done
                                      %debugging

for ii = 1:length(t)
  for jj = 1:numDocs
    W(ii,jj) = (1-epsilon(ii))*C(ii,jj)/n(jj);
  end
end
dlmwrite('W.txt',W,' ')
clear C
[U,S,V] = svds(W,numSV);
clear W
B = S*V';
dlmwrite('train.csv',B',',')
clear S
clear V
fileList = textread(testList,'%s');
C = zeros(numWords+numWords*numWords,length(fileList));
numDocs = length(fileList);
for fileNum = 1:numDocs
  x = dlmread(fileList{fileNum});
  for n = 1:numWords
    C(n,fileNum) = length(find(x == n));
  end
  temp = zeros(numWords,numWords);
  for n = 2:length(x)
    temp(x(n),x(n-1)) = temp(x(n),x(n-1)) + 1;
  end
  C((numWords+1):end,fileNum) = temp(:);
end
dlmwrite('Ctest.txt',C,' '); %<---Remove this after done debugging
Q = zeros(size(C));
n = sum(C);

for ii = 1:length(t)
  for jj = 1:numDocs
    Q(ii,jj) = (1-epsilon(ii))*C(ii,jj)/n(jj);
  end
end

dlmwrite('Q.txt',Q,' ')
Q = U'*Q;
dlmwrite('test.csv',Q',',')








quit
