function findEERNIST(nmixYes,nmixNo,thresh)
 
 trainlabs{1} = 'norwegian';
 trainlabs{2} = 'arabic';
 trainlabs{3} = 'english';
 trainlabs{4} = 'farsi';
 trainlabs{5} = 'french';
 trainlabs{6} = 'german';
 trainlabs{7} = 'hindi';
 trainlabs{8} = 'japanese';
 trainlabs{9} = 'korean';
 trainlabs{10} = 'mandarin';
 trainlabs{11} = 'spanish';
 trainlabs{12} = 'tamil';
 trainlabs{13} = 'vietnamese';
 
%trainlabs{1} = 'canadian';
%trainlabs{2} = 'farsi';
%trainlabs{3} = 'german';

ndim = length(trainlabs);
scores = [];
for n = 1:length(trainlabs)
  str = sprintf('nist/%s.predT',trainlabs{n});
  scores(:,n) = dlmread(str);
end
testscores = [];
for n = 1:length(trainlabs)
  str = sprintf('nist/%s.pred',trainlabs{n});
  testscores(:,n) = dlmread(str);
end
testLabels = textread('nist/test.lab','%s');
[numLabs,dummy] = size(testscores);
if (numLabs ~= length(testLabels))
  error('ERROR!')
end
TP = 0;
FP = 0;
TN = 0;
FN = 0;
trainLabels = textread('nist/train.lab','%s');
for n = 1:length(trainlabs)
  str = sprintf('nist/%s.comp',trainlabs{n});
  fid = fopen(str,'w');
  gmmYes = gmm(ndim,nmixYes,'diag');
  gmmNo = gmm(ndim,nmixNo,'diag');
  options = foptions;
  options(14) = 10;
  I = find(strcmp(trainLabels,trainlabs{n})==1);
  gmmYes = gmminit(gmmYes,scores(I,:),options);
  J = find(strcmp(trainLabels,trainlabs{n})~=1);
  gmmNo = gmminit(gmmNo,scores(J,:),options);
  emoptions = zeros(1,18);
  emtions(14) = 20;
  gmmYes = gmmem(gmmYes,scores(I,:),emoptions);
  gmmNo = gmmem(gmmNo,scores(J,:),emoptions);

  for k = 1:numLabs
    testLLR = log(gmmprob(gmmYes,testscores(k,:)))-log(gmmprob(gmmNo,testscores(k,:)));
	%disp(testLLR)
    if (strcmp(testLabels{k},trainlabs{n})==1)
      if (testLLR > thresh)
	fprintf(fid,'%s yes correct\n',testLabels{k});
	TP = TP + 1;
      else
	fprintf(fid,'%s no wrong\n',testLabels{k});
	FN = FN + 1;
      end
    else
      if (testLLR < thresh)
	fprintf(fid,'%s no correct\n',testLabels{k});
	TN = TN + 1;
      else
	fprintf(fid,'%s yes wrong\n',testLabels{k});
	FP = FP + 1;
	testLLR = testLLR;
      end
    end
  end
  fclose(fid);
end

str = sprintf('Thresh %1.3f: TP = %d,TN = %d,FP = %d,FN = %d',thresh,TP,TN,FP,FN);
Acc=100*(TP+TN)/(TP+FP+TN+FN);
Prec=100*(TP)/(TP+FP);
Reca=100*(TP)/(TP+FN);
FScore=(2*TP)/((2*TP)+FP+FN);
disp(str)
disp(Acc)
disp(Prec)
disp(Reca)
disp(FScore)

