function quadlsaNIST(trainList,testList,numWords,numSV)
% trainList=('nist/all.scp');
% testList=('nist/test.scp');
% numWords=10;
% numSV=300;
% numSV = numSV
fileList = textread(trainList,'%s');
C = zeros(numWords+numWords*numWords+numWords^3,length(fileList));
numDocs = length(fileList);
for fileNum = 1:numDocs
  str = sprintf('%s',fileList{fileNum});
  x = dlmread(str);
  xsize = size(x);
%  x = x(:,3);
  for n = 1:numWords
    C(n,fileNum) = length(find(x == n));
  end

  temp = zeros(numWords,numWords);
  for n = 2:length(x)
    temp(x(n),x(n-1)) = temp(x(n),x(n-1)) + 1;
  end
  C((numWords+1):(numWords+numWords^2),fileNum) = temp(:);

  temp = zeros(numWords,numWords,numWords);
  for n = 3:length(x)
    temp(x(n),x(n-1),x(n-2)) = temp(x(n),x(n-1),x(n-2)) + 1;
  end
  C((numWords+numWords^2+1):end,fileNum) = ...
      temp(:);
 
end
dlmwrite('nist/Cquad.txt',C,' '); %<---Remove this after done debugging

W = zeros(size(C));
n = sum(C);
t = sum(C');
epsilon = zeros(1,numWords+numWords*numWords+numWords^3);

for ii = 1:length(t)
  if (t(ii) > 0)
    temp = C(ii,:)./t(ii);
    temp = temp.*log(temp);
    I = find(C(ii,:) == 0);
    temp(I) = 0;
    epsilon(ii) = -1/log(numDocs) * sum(temp);
  end
end

dlmwrite('nist/wordEntropies.txt',epsilon,'\n'); %<---Remove this after done
                                      %debugging

for ii = 1:length(t)
  for jj = 1:numDocs
    W(ii,jj) = (1-epsilon(ii))*C(ii,jj)/n(jj);
  end
end
dlmwrite('nist/W.txt',W,' ')
clear C
[U,S,V] = svds(W,numSV);
clear W
B = S*V';
%B = V';
dlmwrite('nist/train.csv',B','delimiter',',','precision','%.10f')
clear S
clear V
fileList = textread(testList,'%s');
C = zeros(numWords+numWords*numWords+numWords^3,length(fileList));
numDocs = length(fileList);
for fileNum = 1:numDocs
  str = sprintf('%s',fileList{fileNum});
  x = dlmread(str);
%  x = x(:,3);
  for n = 1:numWords
    C(n,fileNum) = length(find(x == n));
  end
  temp = zeros(numWords,numWords);
  for n = 2:length(x)
    temp(x(n),x(n-1)) = temp(x(n),x(n-1)) + 1;
  end
  C((numWords+1):(numWords+numWords^2),fileNum) = temp(:);
  temp = zeros(numWords,numWords,numWords);
  for n = 3:length(x)
    temp(x(n),x(n-1),x(n-2)) = temp(x(n),x(n-1),x(n-2)) + 1;
  end
  C((numWords+numWords^2+1):end,fileNum) = ...
      temp(:);

end
dlmwrite('nist/Cquadtest.txt',C,' '); %<---Remove this after done debugging
Q = zeros(size(C));
n = sum(C);

for ii = 1:length(t)
  for jj = 1:numDocs
    Q(ii,jj) = (1-epsilon(ii))*C(ii,jj)/n(jj);
  end
end

dlmwrite('nist/Q.txt',Q,' ')
Q = U'*Q;
dlmwrite('nist/test.csv',Q','delimiter',',','precision','%.10f')








quit
