function quadlsaOGI(trainList,testList,numWords,numSV)

fileList = textread(trainList,'%s');
C = zeros(numWords+numWords*numWords+numWords^3+numWords^4,length(fileList));
numDocs = length(fileList);
for fileNum = 1:numDocs
  str = sprintf('ogi/recs/%s.lab',fileList{fileNum});
  x = dlmread(str);
  x = x(:,3);
  for n = 1:numWords
    C(n,fileNum) = length(find(x == n));
  end
  temp = zeros(numWords,numWords);
  for n = 2:length(x)
    temp(x(n),x(n-1)) = temp(x(n),x(n-1)) + 1;
  end
  C((numWords+1):(numWords+numWords^2),fileNum) = temp(:);
  temp = zeros(numWords,numWords,numWords);
  for n = 3:length(x)
    temp(x(n),x(n-1),x(n-2)) = temp(x(n),x(n-1),x(n-2)) + 1;
  end
  C((numWords+numWords^2+1):(numWords+numWords^2+numWords^3),fileNum) = ...
      temp(:);
  temp = zeros(numWords,numWords,numWords,numWords);
  for n = 4:length(x)
    temp(x(n),x(n-1),x(n-2),x(n-3)) = temp(x(n),x(n-1),x(n-2),x(n-3)) ...
	+ 1;
  end
%  size( C((numWords+numWords^2+numWords^3+1):end),fileNum)
%  size(temp(:))
  C((numWords+numWords^2+numWords^3+1):end,fileNum) = temp(:);
end
%dlmwrite('ogi/Cquad.txt',C,' '); %<---Remove this after done debugging

W = zeros(size(C));
n = sum(C);
t = sum(C');
epsilon = zeros(1,numWords+numWords*numWords+numWords^3+numWords^4);

for ii = 1:length(t)
  if (t(ii) > 0)
    temp = C(ii,:)./t(ii);
    temp = temp.*log(temp);
    I = find(C(ii,:) == 0);
    temp(I) = 0;
    epsilon(ii) = -1/log(numDocs) * sum(temp);
  end
end

dlmwrite('ogi/wordEntropies.txt',epsilon,'\n'); %<---Remove this after done
                                      %debugging

for ii = 1:length(t)
  for jj = 1:numDocs
    W(ii,jj) = (1-epsilon(ii))*C(ii,jj)/n(jj);
  end
end
%dlmwrite('ogi/W.txt',W,' ')
clear C
[U,S,V] = svds(W,numSV);
clear W
B = S*V';
dlmwrite('ogi/train.csv',B',',')
clear S
clear V
fileList = textread(testList,'%s');
C = zeros(numWords+numWords*numWords+numWords^3+numWords^4,length(fileList));
numDocs = length(fileList);
for fileNum = 1:numDocs
  str = sprintf('ogi/recs/%s.lab',fileList{fileNum});
  x = dlmread(str);
  x = x(:,3);
  for n = 1:numWords
    C(n,fileNum) = length(find(x == n));
  end
  temp = zeros(numWords,numWords);
  for n = 2:length(x)
    temp(x(n),x(n-1)) = temp(x(n),x(n-1)) + 1;
  end
  C((numWords+1):(numWords+numWords^2),fileNum) = temp(:);
  temp = zeros(numWords,numWords,numWords);
  for n = 3:length(x)
    temp(x(n),x(n-1),x(n-2)) = temp(x(n),x(n-1),x(n-2)) + 1;
  end
  C((numWords+numWords^2+1):(numWords+numWords^2+numWords^3),fileNum) = ...
      temp(:);
  temp = zeros(numWords,numWords,numWords,numWords);
  for n = 4:length(x)
    temp(x(n),x(n-1),x(n-2),x(n-3)) = temp(x(n),x(n-1),x(n-2),x(n-3)) ...
	...
        + 1;
  end
  C((numWords+numWords^2+numWords^3+1):end,fileNum) = temp(:);

end
%dlmwrite('ogi/Cquadtest.txt',C,' '); %<---Remove this after done debugging
Q = zeros(size(C));
n = sum(C);

for ii = 1:length(t)
  for jj = 1:numDocs
    Q(ii,jj) = (1-epsilon(ii))*C(ii,jj)/n(jj);
  end
end

%dlmwrite('ogi/Q.txt',Q,' ')
Q = U'*Q;
dlmwrite('ogi/test.csv',Q',',')








quit
