#!/usr/bin/perl
#
# Script for converting a set of TIMIT label files to an HTK MLF.
#
# Input: Timit set (Train, Test, Devel)
#
# Output: HTK MLF, phonelist
#

$Set="";
if ($#ARGV>=0){$Set="$ARGV[0]";}
$filelist="filelist.scp"; # The list of wav files in the set (input)
$mlffile="newnorsk.mlf"; # The resulting mlf
$labellist="NorPhones.list"; # The list of phone symbols found in the set
$Prefix=""; # The location of the TIMIT data (wav and phn files)

$Fs=16000;
$HTKUnit=10000000;
$scale=$HTKUnit/$Fs;
%LabList=();

open(LST,"$filelist") || die "Could not open $filelist\n";
open(MLF,">$mlffile") || die "Could not open $mlffile for writing\n";
print MLF "#!MLF!#\n";

while (<LST>) {
    chomp;
    $_ =~ s/\.wav/\.phn/;
    $in = "$Prefix" . "$Set" . "" . "$_";
	if (($Set eq "cv" ) || ( $Set eq "train_only" )){$in = "$Prefix" . "train_wav/" . "$_";}
    $out="$_";
    $out =~ s/\//_/g;
    $out =~ s/\.phn/\.lab/;
    open(INL,"$in") || die "Could not open label file $in for reading\n";
    print MLF "\"\*/$out\"\n";
    while (<INL>) {
        chomp;
        ($start,$end,$label)=split;
        $startH = int($scale*$start);
        $endH = int($scale*$end);
        print MLF "$startH $endH $label\n";
        if (! exists $LabList{$label} ){
            $LabList{$label}=1;
        }
    }
    print MLF ".\n";
    close(INL);
}
close(INL);
close(MLF); 
open(LAB,">$labellist") || die "Could not open $labellist for writing\n";
for $i (sort keys %LabList){
    print LAB "$i\n";
}
close(LAB);
        
