#!/usr/bin/perl
#
# Script for generating two text files describing the mapping from 
# NAFTA phone symbols to manner and place attributes. 
#
# The raw input for the transcription is taken from $Infile, which is a
# semicolon separated csv file (generated from Excel), where the first
# line contains the field labels, and each line describes the mapping of 
# one phone, placing a 1 in the appropriate manner/place field. 
#
# The mappling is written to the text files Manner_List.txt and Place_List,txt
#
# TSv
#
%list_manner=();
%list_place=();
$Infile="MP_map_NO.csv";
open(IN,"$Infile")|| die "Could not open $Infile\n";
%Manner=();
%Place=();
$first=1;
while(<IN>){
	chomp;
	if ($first==1){
		@elements=split(/;/,$_);
		$Lgth=$#elements;
		$in_place=0;
		for ($i=1;$i<=$Lgth; $i++){
			if ($elements[$i] eq "PLACE"){
				$in_place=1;
				$numPlace=$i;
				next;
			}
			if ($in_place==0){
				$Manner{"$i"}="$elements[$i]";
			} else {
				$Place{"$i"}="$elements[$i]";
			}
		}	
		$first=0;
		next;
	}
	@inline=split(/;/,$_);
	$phone=$inline[0];
	for ($i=1;$i<=$#inline;$i++){
		if ($inline[$i] eq "1"){
			if ($i<$numPlace){
				$list_manner{$phone}=$Manner{$i};
			} else {
				$list_place{$phone}=$Place{$i};
			}
		}
	}
}
close(IN);
open(MAN,">Manner_List.txt") || die "Could not open Manner_List.txt for writing\n";
foreach $i (sort keys %list_manner){
	print MAN "$i $list_manner{$i}\n";
}
close(MAN);

open(PLC,">Place_List.txt") || die "Could not open Place_List.txt for writing\n";
foreach $i (sort keys %list_place){
	print PLC "$i $list_place{$i}\n";
}
close(PLC);
