#!/bin/bash

context=$1
compacted=$2
tristates=$3
do_kalditrain=$4

#test input arguments
if [ \( "$compacted" = "yes"  \) -o \( "$compacted" = "no" \) ] &&  \
	[ \( "$context" = "CI"  \) -o \( "$context" = "LC" \) -o \( "$context" = "RC" \) -o \( "$context" = "TC" \) ] && \
	[ \( "$tristates" = "yes"  \) -o \( "$tristates" = "no" \) ] && \
	[ \( "$do_kalditrain" = "yes"  \) -o \( "$do_kalditrain" = "no" \) ]; then
	echo "---Starting process....."
else
	printf "Usage: ./masterplace.sh context='CI|LC|RC|TC' compacted='yes|no' tristates='yes|no' do_kalditrain='yes|no' \n"
	exit 1
fi

if [ "$compacted" = "yes" ]; then
	com_path="compacted"
else
	com_path="non_compacted"
fi

rm -r out tmp

dict="/home/studenter/oyststa/LRE/create_place/EYSTEIN/dicts/"$com_path"/dict_"$context"_place.dict"
mlf="/home/studenter/oyststa/LRE/create_place/EYSTEIN/attMLFs/"$com_path"/"$context"/combined_"$context".mlf"

./ogi_place_noeng.sh $mlf $dict > ogi_log.txt
if grep -Fxq  ogi_log.txt -e 'ERROR'; then
	printf "Errors found in ogi_place. See ogi_log.txt \n"
	exit 1
else
	printf "No errors in ogi_place. Continuing. \n"
fi
	
if [ "$tristates" = "yes" ]; then
	states=5;
	printf "Tristates chosen. Changing target number and HMM models \n"
	wc_temp=`wc "dicts/"$com_path"/dict_"$context"_place.dict"`
	numlabels=$(echo ${wc_temp[0]}|cut -d' ' -f1)
	numlabels=$(((numlabels+1)*3))
else
	states=3;
	printf "Single state chosen. Changing target number and HMM models \n"
	wc_temp=`wc "dicts/"$com_path"/dict_"$context"_place.dict"`
	numlabels=$(echo ${wc_temp[0]}|cut -d' ' -f1)
	numlabels=$((numlabels+1))
fi

###PFILE2KALDI####

cp -r /home/studenter/oyststa/LRE/create_place/EYSTEIN/out /home/studenter/oyststa/LRE/Pfile2Kaldi/create_kaldi/
cp -r /home/studenter/oyststa/LRE/create_place/EYSTEIN/tmp /home/studenter/oyststa/LRE/Pfile2Kaldi/create_kaldi/

cd /home/studenter/oyststa/LRE/Pfile2Kaldi/create_kaldi

if [ "$tristates" = "yes" ]; then
	#cp /home/studenter/oyststa/LRE/Pfile2Kaldi/create_kaldi/newdict /home/studenter/oyststa/LRE/Pfile2Kaldi/create_kaldi/out/timit_0-16k_23mel_1st/dicts/dict
	./eyscript_tristate.sh
else
	./eyscript.sh
fi

##KALDI##
if [ "$do_kalditrain" = "yes" ]; then
#copying results to kaldi-trunk
cp -r /home/studenter/oyststa/LRE/Pfile2Kaldi/create_kaldi/kaldiformat/ark /home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/
#changing numtgts line in train.sh
#sed "42s/.*/num_tgt=$numlabels/" /home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/steps/nnet/train.sh > tmpvar && mv tmpvar /home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/steps/nnet/train.sh
#changing another line according to place, in train.sh
#line="labels=exp\/place_cd_ali_train\/"
#sed "39s/.*/$line/" /home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/steps/nnet/train.sh > tmpvar && mv tmpvar /home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/steps/nnet/train.sh
#chmod +x /home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/steps/nnet/train.sh

cd /home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/
rm -r data-fbank
mkdir data-fbank
cd data-fbank
mkdir develop lang train test
cd /home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/exp
rm -r place_cd_ali_dev place_cd_ali_test place_cd_ali_train place_pretrain-dbn-dnn place_pretrain-dbn
mkdir place_cd_ali_dev place_cd_ali_test place_cd_ali_train
cd ..
. cmd.sh
. path.sh

copy-feats ark:ark/train.ark.txt ark,scp:/home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/data-fbank/train/train.ark,/home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/data-fbank/train/feats.scp
copy-feats ark:ark/cv.ark.txt ark,scp:/home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/data-fbank/develop/cv.ark,/home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/data-fbank/develop/feats.scp
copy-feats ark:ark/test.ark.txt ark,scp:/home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/data-fbank/test/test.ark,/home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/data-fbank/test/feats.scp

cd exp
cd place_cd_ali_train
gzip -c ../../ark/ali_train_labs.ark > ali.1.gz
cd ../place_cd_ali_test
gzip -c ../../ark/ali_test_labs.ark > ali.1.gz
cd ../place_cd_ali_dev 
gzip -c ../../ark/ali_cv_labs.ark > ali.1.gz
cd /home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/
dir=exp/place_pretrain-dbn
#pretraining
$cuda_cmd $dir/log/pretrain_dbn.log steps/nnet/pretrain_dbn.sh --rbm-iter 3 data-fbank/train/ $dir > pre.log
#fine tuning
dir=exp/place_pretrain-dbn-dnn
ali_train=exp/place_cd_ali_train 
ali_cv=exp/place_cd_ali_dev
feature_transform=exp/place_pretrain-dbn/final.feature_transform 

dbn=exp/place_pretrain-dbn/6.dbn

$cuda_cmd $dir/log/train_nnet.log steps/nnet/train.sh --feature-transform $feature_transform --dbn $dbn --hid-layers 0 --learn-rate 0.008 data-fbank/train data-fbank/develop data-fbank/lang $ali_train $ali_cv $dir > train.log

mkdir /home/studenter/oyststa/LRE/backend/deepnetwork/place/${context}_${states}_${com_path}_noenglish_0
cp /home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/exp/place_pretrain-dbn-dnn/final.nnet /home/studenter/oyststa/LRE/backend/deepnetwork/place/${context}_${states}_${com_path}_noenglish_0/final.nnet
cp /home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/exp/place_pretrain-dbn-dnn/final.feature_transform /home/studenter/oyststa/LRE/backend/deepnetwork/place/${context}_${states}_${com_path}_noenglish_0/final.feature_transform
else
	printf "Kaldi training not chosen. Moving on \n"
fi
#copy the logs etc.
tar -cvf /prosjekt/studenter/oyststa/EXPs/${context}_${states}_${com_path}_noenglish_0.tar.gz /home/studenter/oyststa/kaldi-trunk/egs/ogi/s5/exp
###BACKEND###

#copying hmmlist (dict) to backend
#cp /home/studenter/oyststa/LRE/Pfile2Kaldi/create_kaldi/out/timit_0-16k_23mel_1st/dicts/dict /home/studenter/oyststa/LRE/backend/tristates/scoring/buthmms/hmmlist_$states"_"$context"_"$com_path

#Now, go to the backend and run the script "run_all.sh" with your preferred languages. Also change strbut2htk argument in SVite.sh

#cleanup
#rm /home/studenter/oyststa/LRE/create_place/EYSTEIN/ogi_log.txt
#rm /home/studenter/oyststa/LRE/Pfile2Kaldi/create_kaldi/tempvar
echo "---ALL DONE--- "
