#!/bin/sh

#--- please modify this lines and the param.sh script -----------------------------

data=/talebase/data/speech_raw/OGI_MARCO/OGI
train_list=lists/train.scp
test_list=lists/test.scp
cv_list=lists/cv.scp

htk_mlf=attMLFs/non_compacted/CI/combined_CI.mlf
#htk_mlf=$1
dict=dicts/non_compacted/dict_CI_place.dict
#dict=$2
param_script=param_scripts/hcopy15mel.sh
outdir=out/timit_0-16k_23mel_1st
#----------------------------------------------------------------------------------

# add 'oth' label mark to the dictionary
mkdir tmp
sort $dict > tmp/dict
echo "oth" >> tmp/dict


# get the waveform file extension
first_file=`head -n 1 $train_list`
datafile_expr=`expr $first_file : '.*\.\(.*\)'`

# add correct paths to the waveform file names
find $data -name "*.$datafile_expr" > tmp/all_data_files.lst
scripts/expand_paths.pl $train_list tmp/all_data_files.lst > tmp/train_raw.lst
scripts/expand_paths.pl $test_list tmp/all_data_files.lst > tmp/test_raw.lst
scripts/expand_paths.pl $cv_list tmp/all_data_files.lst > tmp/cv_raw.lst
#rm  tmp/all_data_files.lst

# create pfiles
scripts/create_pfile.sh tmp/train_noflip.pfile tmp/train_raw.lst $htk_mlf tmp/dict $param_script tmp
scripts/create_pfile.sh tmp/test_noflip.pfile tmp/test_raw.lst $htk_mlf tmp/dict $param_script tmp
scripts/create_pfile.sh tmp/cv_noflip.pfile tmp/cv_raw.lst $htk_mlf tmp/dict $param_script tmp

# lists of raw file names
awk '{ n=split($1, a, /\//) ; n1=split(a[n], b, /\./); print b[1] }' $train_list > tmp/train.scp
awk '{ n=split($1, a, /\//) ; n1=split(a[n], b, /\./); print b[1] }' $test_list > tmp/test.scp
awk '{ n=split($1, a, /\//) ; n1=split(a[n], b, /\./); print b[1] }' $cv_list > tmp/cv.scp

# create final directory
mkdir -p $outdir/pfiles
mkdir -p $outdir/lists
mkdir -p $outdir/dicts
mkdir -p $outdir/mlfs

mv tmp/train_noflip.pfile $outdir/pfiles/train.pfile
mv tmp/test_noflip.pfile $outdir/pfiles/test.pfile
mv tmp/cv_noflip.pfile $outdir/pfiles/cv.pfile
mv tmp/train.scp $outdir/lists/train.scp
mv tmp/test.scp $outdir/lists/test.scp
mv tmp/cv.scp $outdir/lists/cv.scp
mv tmp/dict $outdir/dicts/dict
cp $htk_mlf $outdir/mlfs/ref.mlf

