#!/bin/sh

if [ $# -le 5 ] ; then
	echo "USAGE: create_pfile.sh pfile list_or_raw_files mlf dict param_script [tmp_dir] [time_shift]"
	exit 1;
fi

pfile=$1
list=$2
mlf=$3
dict=$4
param_script=$5
tmpdir=$6
time_shift=$7

if [ "$tmpdir" = "" ] ; then
	tmpdir="/tmp/$$"
fi

#create two column list for parameterisation
mkdir -p $tmpdir/features
awk '{ n=split($1, a, /\//) ; sub("\\.[^.]+$", "", a[n]); print $1 " '$tmpdir'/features/" a[n] ".fea" }' $list > $tmpdir/wavfea.lst

#run user defined parameterisation
$param_script $tmpdir/wavfea.lst

#create feature list
awk '{ print $2 }' $tmpdir/wavfea.lst > $tmpdir/features.lst
#rm $tmpdir/wavfea.lst

#create the pfile
/home/studenter/oyststa/LRE/Pfile2Kaldi/PFile_Executable/feacat -l $tmpdir/features.lst -ip htk -o $pfile -op pfile
#rm -r -f $tmpdir/features
#rm $tmpdir/features.lst
#rmdir $tmpdir/features

#add labels to the pfile
if [ "$mlf" != "none" ] ; then 
   scripts/add_labels_to_pfile.pl $pfile $list $mlf $dict $tmpdir $time_shift
fi


