#!/bin/sh

if [ $# -le 5 ] ; then
	echo "USAGE: create_pfile.sh pfile list_or_raw_files mlf dict param_script [tmp_dir] [time_shift]"
	exit 1;
fi

pfile=$1
list=$2
mlf=$3
dict=$4
param_script=$5
tmpdir=$6
time_shift=$7

if [ "$tmpdir" = "" ] ; then
	tmpdir="/tmp/$$"
fi

#create two column list for parameterisation
mkdir -p $tmpdir/features
#awk '{ n=split($1, a, /\//) ; sub("\\.[^.]+$", "", a[n]); print $1 " '$tmpdir'/features/" a[n] ".fea" }' $list > $tmpdir/wavfea.lst

awk '{print "'$tmpdir'/features/" $0}' $list | tr '=' ' ' | awk '{print $2 " " $1;}' > $tmpdir/wavfea.lst

#run user defined parameterisation
echo $param_script $tmpdir/wavfea.lst
$param_script $tmpdir/wavfea.lst

#create feature list
awk '{ print $2 }' $tmpdir/wavfea.lst > $tmpdir/features.lst
rm $tmpdir/wavfea.lst

#create the pfile
feacat -l $tmpdir/features.lst -ip htk -o $pfile -op pfile

echo $tmp

#add labels to the pfile
if [ "$mlf" != "none" ] ; then 
    scripts/add_labels_to_pfile.pl $pfile $tmpdir/features.lst $mlf $dict $tmpdir $time_shift
    echo scripts/add_labels_to_pfile.pl $pfile $tmpdir/features.lst $mlf $dict $tmpdir $time_shift
fi


