#!/usr/bin/perl
##Script to compare a prior pfile with a decoded mlf
##
##Øystein Staven, NTNU, 7 june 2016
#
#Requires an input mlf made with arguments <-o S>

use List::MoreUtils qw(firstidx);
#use strict;
#use warnings;
###################################################################################
##	Check input arguments
###################################################################################
# $num_args = $#ARGV+1;
# if ($num_args != 2) {
#     print "\nUsage: prior_ark.pl <input pfile> <output ark> <priorlist>\n";
#     exit;
# }

###################################################################################
##	Input arguments 
###################################################################################
$input_pfile=$ARGV[0];
$dict="dict_CI_place.dict";
$dictlatex="dictlatex";
#$list="cv.scp";
$input_mlf=$ARGV[1];
###################################################################################
##	Get some info about pfile
###################################################################################
@pfile_info=split(/[\n,\s]+/,`pfile_info -i $input_pfile`);
#make original labs
system("pfile_print -i $input_pfile -o temppfile.txt -q");
$pfile_sentences=$pfile_info[1];
$pfile_frames=$pfile_info[3];
#print "@info\n";
#print "$pfile_sentences\n";
#print "$pfile_frames\n";

$numatts=`cat $dict | wc -l`;
###################################################################################
##	Initialize
###################################################################################
my @starts_array=();
my @stops_array=();
my @phns_array=();
#$time_shift=10*(1e-3); #frame shift constant
$time_shift=1e5;
#my $dir = './tmpdecode'; #temporary folder for recs
#mkdir $dir unless -d $dir;
@attributes=();
	@attributes = do {
	    open $fh, "<", $dict
	        or die "could not open $dict: $!";
	    <$fh>;
	};

close($fh);
@attributeslatex=();
	@attributeslatex = do {
	    open $fh, "<", $dictlatex
	        or die "could not open $dictlatex: $!";
	    <$fh>;
	};

close($fh);
###################################################################################
##	Import MLF and make new continous mlf, then print to two new files
###################################################################################
$mlf_sentences=`grep $input_mlf -e '.rec' | wc -l`;

if ($pfile_sentences != $mlf_sentences){
	die("MLF and pfile has different number of sentences\n");
}
open(FOUT1,">newref.txt") || die("Cannot open newref.txt \n");
open(FOUT2,">reclabs.txt") || die("Cannot open reclabs.txt \n");
open(FIN,"$input_mlf") || die("Cannot open MLF file\n");

	while($line = <FIN>) {
		chomp $line;
		next if ($line =~ m/MLF/);  #skip if it's the MLF header
		next if ($line =~ m/^\./);  #skip if it's the end of sentence
		if ($line =~ m/.rec/) { #this means a new file
		for($el=0;$el<=$#phns_array;$el++) {
			print FOUT1 "$starts_array[$el] $stops_array[$el] $phns_array[$el]\n";
			$idx = firstidx {/$phns_array[$el]/} @attributes;
			print FOUT2 "$idx\n";
		}
		@starts_array=();
		@stops_array=();
		@phns_array=();
		next;
		}
		($start, $stop, $phn) = split /\s+/, $line, 3;
		$diff=$stop-$start;
		#section that takes care of time jumps more than time_shift:
		if($diff == $time_shift){
		push @starts_array, $start;
		push @stops_array, $stop;
		push @phns_array, $phn; }
		else {
			$counter=0;
			push @starts_array, $start;
			$newtime=$start;
			while($counter != $diff){
				$newtime=$newtime+$time_shift;
				push @stops_array, $newtime;
				push @starts_array, $newtime;
				push @phns_array, $phn;
				$counter=$counter+$time_shift;
		}
		
	}
}
#Printing the final file
for($el=0;$el<=$#phns_array;$el++) {
	print FOUT1 "$starts_array[$el] $stops_array[$el] $phns_array[$el]\n";
	$idx = firstidx {/$phns_array[$el]/} @attributes;
	print FOUT2 "$idx\n";
}
close(FIN);
close(FOUT);

open(FIN,"temppfile.txt") || die("Cannot open temppfile.txt\n");
open(FOUT,">lablabs.txt") || die("Cannot open lablabs.txt\n");
while($line = <FIN>) {
	chomp $line;
	@columns= split / /, $line;
	print FOUT "$columns[50]\n";
}
close(FIN);
close(FOUT);

unlink("temppfile.txt");
#unlink("newref.txt");

###################################################################################
##	Make binary recognizer vectors
###################################################################################
open(FIN1,"reclabs.txt") || die("Cannot open reclabs.txt");
open(FIN2,"lablabs.txt") || die("Cannot open lablabs.txt");
open(FOUT1,">binreclabs.txt") || die("Cannot open binreclabs.txt");
open(FOUT2,">binlablabs.txt") || die("Cannot open binlablabs.txt");

while($line = <FIN1>) {
	for($el=0;$el<=$numatts-1;$el++) {
		if ($el == $line)
				{print FOUT1 "1\n";}
			else{print FOUT1 "0\n";}
	}
}

while($line = <FIN2>) {
	for($el=0;$el<=$numatts-1;$el++) {
		if ($el == $line)
				{print FOUT2 "1\n";}
			else{print FOUT2 "0\n";}
	}
}

close(FIN1); close(FIN2);
close(FOUT1); close(FOUT2);

###################################################################################
##	Now for the evaluation for each class
###################################################################################
open(LATEX,">latex.txt") || die("Cannot open latex.txt");
open(MATLAB,">matlab.txt") || die("Cannot open matlab.txt");
@lablabs=(); #import truth labels
	@lablabs = do {
	    open $fh, "<", "binlablabs.txt"
	        or die "could not open binlablabs.txt: $!";
	    <$fh>;
	};
close($fh);
@reclabs=(); #import recognized labels
	@reclabs = do {
	    open $fh, "<", "binreclabs.txt"
	        or die "could not open binreclabs.txt: $!";
	    <$fh>;
	};
close($fh);

for($class=0;$class<=$numatts-1;$class++) {
	 $TP=0; #true positives
	 $FP=0; #false positives
	 $TN=0; #true negatives
	 $FN=0; #false negatives
$globalcount=0;
$counter=0;
foreach my $line (@reclabs) {
	#print "counter: $counter\n";
	#now check for TP,FP,TN,FN
if ($counter==$class)
{
	if ($line==1 and $lablabs[$globalcount]==1) {$TP++;}
	if ($line==1 and $lablabs[$globalcount]==0) {$FP++;}
	if ($line==0 and $lablabs[$globalcount]==0) {$TN++;}
	if ($line==0 and $lablabs[$globalcount]==1) {$FN++;}
}
	$counter++;
	$globalcount++;
	if ($counter == $numatts){$counter=0;}
}
#print "$class: TP: $TP FP: $FP TN: $TN FN $FN\n";
if ($TN == 0 || $TP == 0) {$Acc = $Prec = $Reca = $FScore = "nAn";}
else{
$Acc=100*($TP+$TN)/($TP+$FP+$TN+$FN);
$Prec=100*($TP)/($TP+$FP);
$Reca=100*($TP)/($TP+$FN);
$FScore=(2*$TP)/((2*$TP)+$FP+$FN);
printf MATLAB ("%5.1f %5.1f %5.1f %5.2f \n",$Acc,$Prec,$Reca,$FScore);
}
printf("$attributeslatex[$class] Acc=%5.2f\%, Prec=%5.2f\%, Reca=%5.2f\%, FScore=%5.2f\n",$Acc,$Prec,$Reca,$FScore);
# print latex formatted table
printf LATEX ("%s %s",$attributeslatex[$class],"\&");
printf LATEX ("%5.1f \& %5.1f \& %5.1f \& %5.2f \\\\\n",$Acc,$Prec,$Reca,$FScore);
}

###################################################################################
##	Now for the evaluation for each frame regardless of class
###################################################################################
$TP=0; #true positives
$FP=0; #false positives
$TN=0; #true negatives
$FN=0; #false negatives
$globalcount=0;
$counter=0;
foreach my $line (@reclabs) {
	#print "counter: $counter\n";
	#now check for TP,FP,TN,FN
	if ($line==1 and $lablabs[$globalcount]==1) {$TP++;}
	if ($line==1 and $lablabs[$globalcount]==0) {$FP++;}
	if ($line==0 and $lablabs[$globalcount]==0) {$TN++;}
	if ($line==0 and $lablabs[$globalcount]==1) {$FN++;}

	$globalcount++;
}
#print "Total: TP: $TP FP: $FP TN: $TN FN $FN\n";
if ($TN == 0 || $TP == 0) {$Acc = $Prec = $Reca = $FScore = "nAn";}
else{
$Acc=100*($TP+$TN)/($TP+$FP+$TN+$FN);
$Prec=100*($TP)/($TP+$FP);
$Reca=100*($TP)/($TP+$FN);
$FScore=(2*$TP)/((2*$TP)+$FP+$FN);
printf MATLAB ("%5.1f %5.1f %5.1f %5.2f \n",$Acc,$Prec,$Reca,$FScore);
}
printf("\nTotal: Acc=%5.2f\%, Prec=%5.2f\%, Reca=%5.2f\%, FScore=%5.2f\n",$Acc,$Prec,$Reca,$FScore);

# print latex formatted table
printf LATEX ("Total \&");
printf LATEX ("%5.1f \& %5.1f \& %5.1f \& %5.2f \\\\\n",$Acc,$Prec,$Reca,$FScore);

close(LATEX);

