#!/usr/bin/perl
#
#Script for finding max posterior in an input stream and matching it to a dict
#------------Øystein Staven, NTNU 25 May 2016-----------------------------

###################################################################################
##	Declarations
###################################################################################
use List::Util 'max';
use List::MoreUtils qw(firstidx);
###################################################################################
##	Check input arguments
###################################################################################
$num_args = $#ARGV+1;
if ($num_args != 2) {
    print "\nUsage: eval_nn.pl <dict> <posterior file> \n";
    exit;
}

###################################################################################
##	Input arguments and some conversions
###################################################################################
$dict=$ARGV[0];
$posteriors=$ARGV[1];
$tempposteriors="temp_posteriors.txt";
system("pfile_print -i $posteriors -o $tempposteriors");
#$original=$ARGV[2];
#$temporiginal="temp_original.txt";
#system("pfile_print -i $original -o $temporiginal");
#$numstates=$ARGV[3];
$outputtemp="output_temp.txt";

###################################################################################
##	Initialize
###################################################################################
#open(ORIGINAL,"$temporiginal") || die "Could not open $temporiginal\n";
open(POSTERIORS,"$tempposteriors") || die "Could not open $tempposteriors\n";
open(OUTPUTTEMP,">$outputtemp") || die "Could not open $outputtemp for write\n";


$length=`cat $dict | wc -l`;
@post=();
@maximums=();
#Read the dict into array
@attributes=();
	@attributes = do {
	    open $fh, "<", $dict
	        or die "could not open $dict: $!";
	    <$fh>;
	};

###################################################################################
##	Main loop
###################################################################################

while($line = <POSTERIORS>){
	chomp $line; #remove linebreaks
	my @post= split / /, $line;
	@post = @post[2..$length+1];
	  $maximum = max @post;
	  #print "$maximum\n";#TODO:remove
	  #printf "%i\n", firstidx { $_ eq $maximum } @post;#TODO:remove
	  my $index = firstidx { $_ eq $maximum } @post;
	  #$index=$index-1;#TODO:remove
	  #print "$index\n";#TODO:remove
	  #push @maximums, $index;#TODO:remove
	  print OUTPUTTEMP "$index $attributes[$index]\n";
  }
  
  
  #close(ORIGINAL);
  close(POSTERIORS);
  close(OUTPUTTEMP);
  
  unlink("temp_original.txt");
  unlink("temp_posteriors.txt");
  
  
  
	
	
