#!/usr/bin/perl
#
# Script for converting a kaldi archive containing posteriors (can be used for all archives, I believe)
# to a binary pfile.
# The script assumes that the kaldi utility copy_feats and teh pfile-utilities pfile_create are both on
# the path.
# Label information can be added later using pfile_labs with the resulting pfile, the filelist and the
# corresponding mlf as input.
#
# TSv May 18, 2016.
######################################################################################################
##	Check input arguments
###################################################################################
$num_args = $#ARGV+1;
if ($num_args < 2) {
    print "\nUsage: post2pfile.pl <input .ark> <output pfile>\n";
    exit;
}

#$arkfile="/home/studenter/oyststa/LRE/backend/tristates/scoring/OGInoeng_train_out.ark";
$arkfile=$ARGV[0];
#$postfile="OGInoeng_kaldi.txt";
$postfile="temp_ark.txt";
system("copy-feats ark:$arkfile ark,t:$postfile");
# Define the output filenames
$txtpost="temp_kaldi.txt";      # (temporary) pfile-format version of kaldi archive
$pfile=$ARGV[1];      # the binary pfile
$filelist="temp_files";   # the list of the files in the dataset contained in the kaldi archive
#$priorfile=$ARGV[3];
######################################################################################################
# Initialize - open files and initialize variables
open(POST,"$postfile") || die "Could not open $postfile\n";
open(TXT,">$txtpost") || die "Could not open $txtpost for \n";

$count=0;
$frames=0;
@feats=();
@sourcefiles=();
#@priors=();
#read priors into array
# unless ($num_args == 3)
# {
# 	@priors = do {
# 	    open $fh, "<", $priorfile
# 	        or die "could not open $priorfile: $!";
# 	    <$fh>;
# 	};
#
#  close($fh);}

# for($el=0;$el<=302;$el++) {
# 	print "$priors[$el]";
# }
# The main loop, reading the input file line by line
while( <POST>){
	chomp;
	$_=~ s/^  //g;
	@feats=split(/ /,$_);
	$length=$#feats;

	# Determine if the line designates the start of a new file
	if ($feats[$length] eq "["){
		$sourcefiles[$count]="$feats[0]";
		next;
	}

	# If not, print file and frame number followed by the features
	print TXT "$count $frames";
	if ($frames==0){
		$fealgth=$length;
		$numfeats=$fealgth+1;
	}
	for ($i=0;$i<$fealgth;$i++){
		print TXT " $feats[$i]";
	}
	print TXT " $feats[$i]\n";
	if ($fealgth==$length){
		$frames++;
	} else {    	# The final frame of a fle has an additional element 
		$frames=0;
		$count++;
	}
}
close(POST);
close(TXT);

# Print out the list of files

system("pfile_create -i $txtpost -f $numfeats -l 0 -o $pfile");
# open(LIST,">$filelist") || die "Could not open $filelist for writing\n";
# for ($i=0;$i<=$#sourcefiles;$i++){
# 	print LIST "$sourcefiles[$i]\n";
# }
# close(LIST);
unlink("$txtpost");
unlink("$postfile");