#/usr/bin/perl
#---Øystein Staven----
##This file removes discontinuities in each individual label file and then concatenates them into one again.
##
#
#use warnings;

$num_args = $#ARGV+1;
if ($num_args != 2) {
    print "\nUsage: removdisc.pl <inputmlf> <outputmlf>\n";
    exit;
}

$mlf=$ARGV[0];
$newmlf=$ARGV[1];

my $dir = './tmpremov';
mkdir $dir unless -d $dir;

open MLF, "$mlf" or die "ERROR: Can not open the MLF: $mlf.";
$header  = <MLF>;
my $filename = 0;
while($line = <MLF>)
{
	chomp $line;
	#first make a new file per sentence
	if ($line =~ m/rec/) {
		open $fileREC, ">>", "reclist.txt" or die "Can't open 'reclist.txt'\n";
		print $fileREC "$line\n";
		close $fileREC;

		my $filename = $filename ++;
		 open $fileHandle, ">>", "$dir/$filename.txt" or die "Can't open '$dir/$filename.txt'\n";
		 #print $fileHandle "$line\n";
		 close $fileHandle;
	}
	#then find its contents, print to arrays
		unless ($line =~ m/rec/ || $line =~ m/MLF/ || $line =~ m/\./){
				#print contents to file
				open $fileHandle, ">>", "$dir/$filename.txt" or die "Can't open '$dir/$filename.txt'\n";
	   			print $fileHandle "$line\n";
	   			close $fileHandle;
			}
}
close MLF;

unlink("./tmpremov/0.txt");

open $fixed, ">>", "$newmlf" or die "Can't open '$newmlf'\n"; #this will be the final output
print $fixed "\#\!MLF\!\#\n";
close $fixed or die "Can't close '$newmlf'\n"; #this will be the final output

@reclist_array=();
open $reclist, "<", "reclist.txt" or die "Can't open 'reclist.txt'\n"; #list of rec files
while($line = <$reclist>)
{
	push @reclist_array, $line;
}
close $reclist or die "can't read close '$reclist': $OS_ERROR";

my $dircount;
opendir(my $dh, $dir) or die "opendir($dir): $!";
while (my $de = readdir($dh)) {
  next if $de =~ /^\./ or $de =~ /config_file/;
  $dircount++;
}
closedir($dh);

my $countvar = 1; #variable for printing correct filename
my $dir = './tmpremov';

my $differences = 0;
#foreach my $fp ("$dir/$countvar.txt")
for($countvar=1;$countvar<=$dircount;$countvar++)
{
	my $fp="$dir/$countvar.txt";
	#print "$countvar\n";
	#print "$fp\n";
	#initialize arrays for new file
	
   	@starts_array = (); 
   	@stops_array = (); 
   	@phonemes_array = ();
	
  open my $fh, "<", $fp or die "can't read open '$fp': $OS_ERROR";

  while ($curline = <$fh>) {
	  #push values from the current file to array.
			($start, $stop, $phn) = split /\s+/, $curline, 3;
				push @starts_array, $start; 
				push @stops_array, $stop; 
				push @phonemes_array, $phn;
  }
  close $fh or die "can't read close '$fp': $OS_ERROR";
 
  #we only count from one, to avoid the 0 100000 difference.
  
  for($index=1;$index<=$#starts_array;$index++){
	  $last=$index-1;
    if ("$starts_array[$index]" ne "$stops_array[$last]")
    {
		open $LOG, ">>", "log.txt" or die "Can't open 'log.txt'\n";
		$starts_array[$index] = $stops_array[$index-1];
		
		my $differences = $differences ++;
		print $LOG "File: $countvar Start: $index Stop: $last\n $starts_array[$index] $stops_array[$last]\n";
		close $LOG;
  	}
  }

  
  open my $fh, ">", $fp or die "can't read open '$fp': $OS_ERROR";
  for($index=0;$index<=$#starts_array;$index++){
  printf $fh "%s %s %s", $starts_array[$index], $stops_array[$index], $phonemes_array[$index];
}
print $fh ".\n";
close $fh or die "can't read close '$fp': $OS_ERROR";

open INFILE, "<", $fp or die "can't read open '$fp': $OS_ERROR";
open OUTFILE, ">>", "$newmlf" or die "Can't open '$newmlf'\n"; #this will be the final output

print OUTFILE "$reclist_array[$countvar-1]";

open my $fh, "<", $fp or die "can't read open '$fp': $OS_ERROR";
while ($curline = <$fh>) {
print OUTFILE $curline;
}
close $fh or die "can't read close '$fp': $OS_ERROR";
close OUTFILE or die "can't close $newmlf";
#my $countvar = $countvar + 1;
%$starts_array=();  %$stops_array=(); %$phonemes_array=();
}

rmdir "./tmpremov";
unlink("reclist.txt");

print "\nNumber of differences between starts and stops were: $differences\n";
