#!/usr/bin/perl
#
# Creates HMM for decoding when posteriors are estimated by ANN/DNN
#


$num_args = $#ARGV + 1;
if ($num_args != 2) {
    print "\nUsage: MakeProtoHMM.pl numStates numTargets\n";
    exit;
}
##########################################################################
$hmmlist="hmmlist";      # List of models
$hmmproto="hmmproto";    # Output model file
#$numStates=5;            # Number of states in each HMM
#$vecSize=33;            # Feature vector size (size of ANN output layer)
$numStates=$ARGV[0];
$vecSize=$ARGV[1];
#$hmmlist=$ARGV[2];
##########################################################################

$numStates1=$numStates-1;

open(LIST,"$hmmlist") || die "Could not open $hmmlist for reading \n";
open(PROTO,">$hmmproto") || die "Could not open $hmmproto for writing\n";
print PROTO "~o <VecSize> $vecSize <USER>\n";
$outpos=1;
while(<LIST>){
	chomp;
	$unit=$_;
	for ($i=2;$i<$numStates;$i++){
		print PROTO "~s \"${unit}__$i\"\n";
		print PROTO "<Mean> $vecSize\n";
		for ($j=1;$j<$vecSize;$j++){
			print PROTO "0 ";
		}
		print PROTO "0\n";
		print PROTO "<Variance> $vecSize\n";
		for ($j=1;$j<$vecSize;$j++){
			if ($j == $outpos){
				print PROTO "1.0 "
			} else {
				print PROTO "1e30 ";
			}
		}
		if ($outpos == $vecSize){
			print PROTO "1.0\n";
		} else {
			print PROTO "1e30\n";
		}
		$outpos++;
		print PROTO "<GConst> 0\n";
	}
}
seek(LIST,0,0);
while(<LIST>){
	chomp;
	$unit=$_;
	print PROTO "~h \"$unit\"\n";
	print PROTO "<BeginHMM>\n";
	print PROTO "<NumStates> $numStates\n";
	for ($i=2;$i<$numStates;$i++){
		print PROTO "<State> $i ~s \"${unit}__$i\"\n";
	}
	print PROTO "<TransP> $numStates\n";
	for ($i=1;$i<=$numStates;$i++){
		for ($j=1;$j<$numStates;$j++){
			if ($i == $numStates){print PROTO "0 "; next;}
			if ($j < $i){print PROTO "0 "; next;}
			if ($i == 1 ){
				if ($j==2){
					print PROTO "1 ";
				} else {
					print PROTO "0 ";
				}
				next;
			}
			if ($i > 1){
				$diff=$j-$i;
				if ($diff <=1){
					print PROTO "0.5 "
				} else {
					print PROTO "0 ";
				}
			}
		}
		if ($i == $numStates1){
			print PROTO "0.5\n";
		} else {
			print PROTO "0\n";
		}
	}
	print PROTO "<EndHMM>\n";
}
close(LIST);
close(PROTO);
